<?

 /*************************************************************************************
 * Filename: modules/updates.php
 *
 * This file is part of the ITS JAS plugin.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The ITS JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/its/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_its_updates extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   $this->data->title="ITS updates";
   $this->data->addField("text", "text", "all", "title;markup", 5, 10000, false, "Update");

   $this->data->defaultFields();

   $this->data->addField("issuenr", "nr", "show;sql", "", 1, false, 0);
   $this->data->addReference("issue", "its_issues", "nr", "*:1", "issuenr");

   $this->data->sortOrder("updated");
  }

  function addPostSubmit()
  {
   if(isset($this->dontSendEmail)&&$this->dontSendEmail)
    return true;

   $d=Data::cache("its_issues", "view", "item");
   return $d->moduleObject->sendEmail($this->data->getValue("issuenr"));
  }

  static function add($issuenr, $text, $sendEmail=true)
  {
   //get issue catnr
   $d=Data::cache("its_issues", "view", "item");
   $d->setValue("nr", $issuenr);
   $d->setShowFields("catnr");

   if(!$d->get()||!$d->next())
   {
    /*
    if(isset($this))
    {
     $this->data->e->add("Unable to add issue update", "error", "Can't get issue category");
     $this->data->e->add($d->e);
    }
     */
    return false;
   }

   $catnr=$d->v["catnr"];

   //get updates catnr
   $d=Data::cache("categories", "view", "all");
   $d->clearValues();
   $d->setValue("catnr", $catnr);
   $d->setValue("text", "ITS UPDATES CONTAINER");
   $d->setValue("show_total", 1);
   $d->setShowFields("nr");

   if(!$d->get()||!$d->next())
   {
    /*
    if(isset($this))
    {
     $this->data->e->add("Unable to add issue update", "error", "Can't get updates category");
     $this->data->e->add($d->e);
    }
     */
    return false;
   }

   $catnr=$d->v["nr"];

   //add update
   $d=Data::cache("its_updates", "add", "item");
   $d->moduleObject->dontSendEmail=($sendEmail?false:true);
   $d->clearValues();
   $d->setValue("catnr", $catnr);
   $d->setValue("issue", $issuenr);
   $d->setValue("text", $text);

   if(!$d->submit())
   {
    /*
    if(isset($this))
    {
     $this->data->e->add("Unable to add issue update", "error");
     $this->data->e->add($d->e);
    }
     */
    return false;
   }

   return true;
  }
 }
?>
