<?

 /*************************************************************************************
 * Filename: setup.php
 *
 * This file is part of the ITS JAS plugin.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The ITS JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/its/
 *************************************************************************************/


 class Plugin_Setup_its extends Base_Plugin_Setup
 {
  function init()
  {
   global $_path;

   $this->modules();

   //copy css
   $this->mkdir($_path["project"]["style"]);
   $this->file("setup/its.css", $_path["project"]["style"]);

   return true;
  }

  function postSetup()
  {
   $ITSID="ITS CONTAINER";
   $UPDATEID="ITS UPDATES CONTAINER";
   $FILESID="ITS FILES CONTAINER";

   //get root category
   $d=Data::cache("categories", "tree", "down");
   $d->setShowFields("nr");

   $d->setValue("catnr", 0);
   $d->setValue("treedepth", 0);

   if(!$d->get()||!$d->next())
   {
    $this->e->add("Root category not found");
    $this->e->add($d->e);
    return false;
   }

   $rootcatnr=$d->v["nr"];

   //get its category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $rootcatnr);
   $d->setValue("text", $ITSID);

   if(!$d->get()||!$d->next()) //no its category found
   {
    //add new its category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $rootcatnr);
    $d->setValue("name", "ITS");
    $d->setValue("text", $ITSID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("its_issues", "its_tags", "its_projects", "workflow"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("ITS category added", "note");

    $itscatnr=$d->getValue("nr");
   }
   else //its category found
   {
    //update if necessary
    $itscatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("its_issues", $d->v["module"])||
     !in_array("its_tags", $d->v["module"])||
     !in_array("its_projects", $d->v["module"])||
     !in_array("workflow", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $itscatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("its_issues", "its_tags", "its_projects", "workflow"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("ITS category updated", "note");
    }
   }


   //get its updates category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();
   $d->e->clear();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $itscatnr);
   $d->setValue("text", $UPDATEID);

   if(!$d->get()||!$d->next()) //no its category found
   {
    //add new its category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $itscatnr);
    $d->setValue("name", "Updates");
    $d->setValue("text", $UPDATEID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("its_updates"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("ITS updates category added", "note");

    $updatescatnr=$d->getValue("nr");
   }
   else //its category found
   {
    //update if necessary
    $updatescatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("its_updates", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $updatescatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("its_updates"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("ITS updates category updated", "note");
    }
   }


   //get its files category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();
   $d->e->clear();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $itscatnr);
   $d->setValue("text", $FILESID);

   if(!$d->get()||!$d->next()) //no its category found
   {
    //add new its category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $itscatnr);
    $d->setValue("name", "Files");
    $d->setValue("text", $FILESID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("its_files"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("ITS files category added", "note");

    $filescatnr=$d->getValue("nr");
   }
   else //its category found
   {
    //update if necessary
    $filescatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("its_files", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $filescatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("its_files"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("ITS files category updated", "note");
    }
   }


   //default project
   $d=Data::cache("its_projects", "view", "all");

   $d->clearValues();
   $d->setValue("catnr", $itscatnr);
   $d->setValue("code", "GEN");

   if(!$d->get())
   {
    $this->e->add($d->e);
    return false;
   }

   if(!$d->next()) //no default project
   {
    $d->setAction("add");
    $d->setExtra("item");

    $d->clearValues();
    $d->setValue("catnr", $itscatnr, 0);
    $d->setValue("code", "GEN", 0);
    $d->setValue("name", "General issues", 0);

    $d->setValue("catnr", $itscatnr, 1);
    $d->setValue("code", "PLGN", 1);
    $d->setValue("name", "General issues", 1);

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
   }


   //create workflows
   $d=Data::cache("workflow", "view", "all");

   $d->clearValues();
   $d->setValue("workflow", 0);

   $d->setShowFields("name");

   if(!$d->get())
   {
    $this->e->add($d->e);
    return false;
   }

   $workflows=Array();
   while($d->next())
    $workflows[$d->v["nr"]]=$d->v["name"];

   if(!in_array("ITS - Default", $workflows)) //Default workflow not found
   {
    $this->createWorkflow("ITS - Default", $itscatnr, Array(
     Array("text" => "Open",
     ),
     Array("type" => "Decision",
           "text" => "Close",
           "decisionResult1" => "Close",
           "previousStates" => Array("Open")
     ),
     Array("type" => "State",
           "text" => "Closed",
           "code" => "CLOSED",
           "previousDecisionResults" => Array("Close -> Close")
     ),
     Array("type" => "Decision",
           "text" => "Reopen",
           "decisionResult1" => "Reopen",
           "previousStates" => Array("Closed")
     ),
    ), Array( //update after all has been inserted
     Array("text" => "Open",
           "previousDecisionResults" => Array("Reopen -> Reopen")
     ),
    ));
   }

   return true;
  }

  function createWorkflow($name, $catnr, $values, $updates=false)
  {
   $d=Data::cache("workflow", "add", "item");

   //add workflow entry
   $d->clearValues();
   $d->setValue("name", $name);
   $d->setValue("workflow", 0);
   $d->setValue("text", $values[0]["text"]); //use state text from first entry
   $d->setValue("catnr", $catnr);

   $d->moduleObject->customizeFields();
   if(!$d->submit())
   {
    $this->e->add($d->e);
    return false;
   }

   //get workflow nr
   $workflow=$d->getValue("nr");

   //store entry nr in case it must be updated after everything has been inserted
   if($updates)
   {
    for($x=0;$x<sizeof($updates);$x++)
    {
     if($updates[$x]["text"]==$values[0]["text"])
     {
      $updates[$x]["nr"]=$d->getValue("nr");
      $updates[$x]["type"]="State";
     }
    }
   }

   //insert all states and decisions
   for($c=1;$c<sizeof($values);$c++)
   {
    $d->clearValues();

    foreach($values[$c] as $key => $value)
     $d->setValue($key, $value);

    $d->setValue("workflow", $workflow);
    $d->setValue("catnr", $catnr);

    $d->moduleObject->customizeFields();
    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }

    //store entry nr in case it must be updated after everything has been inserted
    if($updates)
    {
     for($x=0;$x<sizeof($updates);$x++)
     {
      if($updates[$x]["text"]==$values[$c]["text"])
      {
       $updates[$x]["nr"]=$d->getValue("nr");
       $updates[$x]["type"]=$values[$c]["type"];
      }
     }
    }
   }

   //update entries
   $d->setAction("edit");
   $d->setExtra("item");

   for($x=0;$x<sizeof($updates);$x++)
   {
    if(!isset($updates[$x]["nr"]))
    {
     $this->e->add("Unable to determine identifier for state/decision \"".$updates[$x]["text"]."\" of workflow \"".$name."\"");
     return false;
    }

    $d->clearValues();

    foreach($updates[$x] as $key => $value)
     $d->setValue($key, $value);

    if($workflow!=$updates[$x]["nr"]) //not main workflow, added workflow nr for info gathering
     $d->setValue("workflow", $workflow);

    $d->moduleObject->customizeFields();
    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
   }

   $this->e->add($name." workflow created", "note");
   return true;
  }

 }
?>
